import 'package:decorated_flutter/decorated_flutter.dart';
import 'package:flutter/material.dart';
import 'package:nim_fluttify/nim_fluttify.dart';

import '../mixins.dart';

class EnterChatroomScreen extends StatefulWidget {
  @override
  _EnterChatroomScreenState createState() => _EnterChatroomScreenState();
}

class _EnterChatroomScreenState extends State<EnterChatroomScreen>
    with AccountTokenMixin {
  EnterChatRoomResultVM _vm;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('进入聊天室')),
      body: Center(
        child: DecoratedColumn(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text('聊天室id: 174163847'),
            RaisedButton(
              onPressed: _handleLogin,
              child: Text('进入聊天室'),
            ),
            if (_vm != null) _ChatRoom(_vm),
          ],
        ),
      ),
    );
  }

  void _handleLogin() async {
    final resultData = await Nim.instance
        .enterChatRoom('174163847')
        .loading(context)
        .catchError((error) => fail());
    _vm = await EnterChatRoomResultVM.data(resultData);
    setState(() {});
  }
}

class EnterChatRoomResultVM {
  static Future<EnterChatRoomResultVM> data(EnterChatRoomResult data) async {
    return EnterChatRoomResultVM()
      ..roomId = await data.roomId
      ..announcement = await data.announcement
      ..broadcastUrl = await data.broadcastUrl
      ..creator = await data.creator
      ..onlineUserCount = await data.onlineUserCount
      ..name = await data.name;
  }

  String roomId;
  String name;
  String announcement;
  String broadcastUrl;
  String creator;
  int onlineUserCount;
}

class _ChatRoom extends StatelessWidget {
  const _ChatRoom(this.vm, {Key key}) : super(key: key);

  final EnterChatRoomResultVM vm;

  @override
  Widget build(BuildContext context) {
    return DecoratedColumn(
      children: <Widget>[
        Text('聊天室id: ${vm.roomId}'),
        Text('聊天室名称: ${vm.name}'),
        Text('聊天室公告: ${vm.announcement}'),
        Text('聊天室创建人: ${vm.creator}'),
        Text('聊天室人数: ${vm.onlineUserCount}'),
      ],
    );
  }
}
