import 'package:decorated_flutter/decorated_flutter.dart';
import 'package:flutter/material.dart';
import 'package:nim_fluttify/nim_fluttify.dart';
import 'package:nim_fluttify_example/src/mixins.dart';

class SendCustomMessageScreen extends StatefulWidget {
  @override
  _SendCustomMessageScreenState createState() =>
      _SendCustomMessageScreenState();
}

class _SendCustomMessageScreenState extends State<SendCustomMessageScreen>
    with AccountTokenMixin {
  final _controller = TextEditingController(text: '{"test_custom":"测试消息"}');

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('发送自定义消息')),
      body: Center(
        child: DecoratedColumn(
          padding: EdgeInsets.all(kSpaceBig),
          children: <Widget>[
            Text('发送方: $testAccount'),
            Text('单聊接收方: $peerAccount'),
            Text('聊天室id: $chatRoomId'),
            TextFormField(controller: _controller),
            RaisedButton(
              onPressed: _handleSendText,
              child: Text('发送单聊信息'),
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: <Widget>[
                RaisedButton(
                  onPressed: handleEnterChatRoom,
                  child: Text('进入聊天室'),
                ),
                SPACE_NORMAL,
                RaisedButton(
                  onPressed: _handleSendChatRoomCustom,
                  child: Text('发送聊天室信息'),
                ),
              ],
            ),
          ],
        ),
      ),
    );
  }

  void _handleSendText() async {
    if (_controller.text.isNotEmpty) {
      Nim.instance
          .sendCustomMessage(
            sessionId: peerAccount,
            type: SessionType.p2p,
            attachmentString: _controller.text,
          )
          .loading(context, cancelable: true)
          .catchError(handle(context));
    } else {
      toast('发送内容不能为空');
    }
  }

  void _handleSendChatRoomCustom() async {
    if (_controller.text.isNotEmpty) {
      Nim.instance
          .sendCustomMessage(
            sessionId: chatRoomId,
            type: SessionType.chatroom,
            attachmentString: _controller.text,
          )
          .loading(context, cancelable: true)
          .catchError(handle(context));
    } else {
      toast('发送内容不能为空');
    }
  }
}
