import 'package:decorated_flutter/decorated_flutter.dart';
import 'package:flutter/material.dart';
import 'package:nim_fluttify/nim_fluttify.dart';
import 'package:nim_fluttify_example/src/mixins.dart';

class SendTextScreen extends StatefulWidget {
  @override
  _SendTextScreenState createState() => _SendTextScreenState();
}

class _SendTextScreenState extends State<SendTextScreen>
    with AccountTokenMixin {
  final _controller = TextEditingController(text: '测试消息');
  String _sessionId;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('发送文本消息')),
      body: Center(
        child: DecoratedColumn(
          padding: EdgeInsets.all(kSpaceBig),
          children: <Widget>[
            Text('发送方: $testAccount'),
            Text('单聊接收方: $peerAccount'),
            Text('聊天室id: $chatRoomId'),
            TextFormField(controller: _controller),
            RaisedButton(
              onPressed: _handleSendP2PText,
              child: Text('发送单聊信息'),
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: <Widget>[
                RaisedButton(
                  onPressed: handleEnterChatRoom,
                  child: Text('进入聊天室'),
                ),
                SPACE_NORMAL,
                RaisedButton(
                  onPressed: _handleSendChatRoomText,
                  child: Text('发送聊天室信息'),
                ),
              ],
            ),
          ],
        ),
      ),
    );
  }

  void _handleSendP2PText() async {
    if (_controller.text.isNotEmpty) {
      Nim.instance
          .sendTextMessage(
            sessionId: peerAccount,
            type: SessionType.p2p,
            content: _controller.text,
          )
          .loading(context);
    } else {
      toast('发送内容不能为空');
    }
  }

  void _handleSendChatRoomText() {
    if (_controller.text.isNotEmpty) {
      Nim.instance
          .sendTextMessage(
            sessionId: chatRoomId,
            type: SessionType.chatroom,
            content: _controller.text,
          )
          .loading(context);
    } else {
      toast('发送内容不能为空');
    }
  }
}
