import 'dart:io';

import 'package:decorated_flutter/decorated_flutter.dart';
import 'package:flutter/material.dart';
import 'package:nim_fluttify/nim_fluttify.dart';

mixin AccountTokenMixin<T extends StatefulWidget> on State<T> {
  String testAccount;
  String testToken;

  String peerAccount;
  String peerToken;

  String chatRoomId = '174163847';

  String result;

  @override
  void initState() {
    super.initState();
    if (Platform.isAndroid) {
      testAccount = '202006051011246953uxtjm';
      testToken = '033d26a1bbe94d269666e4a5c07b8c33';

      peerAccount = '20200605094955510dfypjj';
      peerToken = '26d9dcf780824d47899e228d029daeb1';
    } else if (Platform.isIOS) {
      testAccount = '20200605094955510dfypjj';
      testToken = '26d9dcf780824d47899e228d029daeb1';

      peerAccount = '202006051011246953uxtjm';
      peerToken = '033d26a1bbe94d269666e4a5c07b8c33';
    }
  }

  void success() {
    setState(() {
      result = '操作成功';
    });
  }

  void fail() {
    setState(() {
      result = '操作失败';
    });
  }

  void clearResult() {
    setState(() {
      result = '';
    });
  }

  void handleEnterChatRoom() {
    Nim.instance
        .enterChatRoom(chatRoomId)
        .loading(context)
        .then((value) => toast('进入聊天室'))
        .catchError(handle(context));
  }
}
