import 'package:decorated_flutter/decorated_flutter.dart';
import 'package:flutter/material.dart';
import 'package:nim_fluttify/nim_fluttify.dart';
import 'package:nim_fluttify_example/src/mixins.dart';

class RecentSessionScreen extends StatefulWidget {
  @override
  _RecentSessionScreenState createState() => _RecentSessionScreenState();
}

class _RecentSessionScreenState extends State<RecentSessionScreen>
    with AccountTokenMixin {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('获取最近会话列表')),
      body: PreferredFutureBuilder<List<_SessionVM>>(
        future: _fetchRecentSession(),
        builder: (data) {
          return ListView.builder(
            itemCount: data.length,
            itemBuilder: (context, index) {
              return _SessionItem(data[index]);
            },
          );
        },
      ),
    );
  }

  Future<List<_SessionVM>> _fetchRecentSession() async {
    final messageList = await Nim.instance.fetchSessionList();
    return [for (final friend in messageList) await _SessionVM.data(friend)];
  }
}

class _SessionVM {
  static Future<_SessionVM> data(RecentSession data) async {
    return _SessionVM()..time = await data.time;
  }

  DateTime time;
}

class _SessionItem extends StatelessWidget {
  const _SessionItem(this.vm, {Key key}) : super(key: key);

  final _SessionVM vm;

  @override
  Widget build(BuildContext context) {
    return Card(
      child: DecoratedColumn(
        padding: EdgeInsets.all(kSpaceNormal),
        children: <Widget>[
          Text('会话时间: ${vm.time}'),
        ],
      ),
    );
  }
}
